#include "instrumenter.h"
#include "kapi.h"

//------------------------------------------------------------------------

// Create an empty counter set
kapi_hwcounter_set::kapi_hwcounter_set()
{
   for (unsigned i=0; i<numCounters; i++) {
      state.cccr_vals[i] = 0;
      state.escr_vals[i] = 0;
   }
   state.pebs_msrs[0] = 0; // ia32_pebs_enable
   state.pebs_msrs[1] = 0; // msr_pebs_matrix_vert
}

// Insert a counter in the set. If its slot is already occupied,
// force our counter in this slot. Return the old value of the slot
kapi_hwcounter_kind kapi_hwcounter_set::insert(kapi_hwcounter_kind kind)
{
   kapi_hwcounter_kind ret = HWC_NONE;
   return ret;
}

// Check to see if the given counter can be enabled with no conflicts
bool kapi_hwcounter_set::conflictsWith(kapi_hwcounter_kind kind) const
{
   return false;
}

// Check to see if two sets are equal
bool kapi_hwcounter_set::equals(const kapi_hwcounter_set &hwset) const
{
   for (unsigned i=0; i<numCounters; i++) {
      if((state.cccr_vals[i] != hwset.state.cccr_vals[i]) ||
         (state.escr_vals[i] != hwset.state.escr_vals[i]))
         return false;
   }
   if((state.pebs_msrs[0] != hwset.state.pebs_msrs[0]) ||
      (state.pebs_msrs[1] != hwset.state.pebs_msrs[1]))
         return false;
   return true;
}

// Find an enabled counter for this kind of counter, assert if not found
unsigned kapi_hwcounter_set::findCounter(kapi_hwcounter_kind kind) const
{
   return 0;
}

// Free a slot occupied by the counter
void kapi_hwcounter_set::free(kapi_hwcounter_kind kind)
{

}

extern instrumenter *theGlobalInstrumenter;

// Find what counters are enabled in the hardware
ierr kapi_hwcounter_set::readConfig()
{
   assert(theGlobalInstrumenter != 0);
   return 0;
}

// Do the actual programming of the counters
ierr kapi_hwcounter_set::writeConfig()
{
    assert(theGlobalInstrumenter != 0);
    return 0;
}
