// power_directToMemoryEmitter.C

#include "power_directToMemoryEmitter.h"

extern void flush_a_little(kptr_t); // .s file

// The following isn't static because various launchers use it.  In fact it's
// so general that it should probably be moved.
void flush_a_bunch(kptr_t iaddr, unsigned numbytes) {
   // flush requires 4-byte alignment.  We don't enforce this (by nand'ing with 0x3)
   // because we know that we're already 4-byte aligned.
   //It is unclear what the instruction cache block size is on Power processors, and 
   //whether it varies.  Let's be safe for now, and leave it as 4
   register kptr_t addr = iaddr;

   while (numbytes) {
//      flush_a_little(addr); // asm
      asm("icbi $0, %0" : /* no outputs */ : "r" (addr));
      addr += 4;
      numbytes -= 4;
   } 
}

void power_directToMemoryEmitter::complete() {
   // We just wrote a bunch of instructions.  They just made it to the data cache.
   // We need to issue cache block invalidate instructions to make sure they reach
   // the icache
   
   assert(insnBytesEmitted <= totalNumInsnBytesOKToWrite);
   flush_a_bunch(whereEmittingStartsInKerninstd, insnBytesEmitted);
}

